diff -dcrpN postgresql.orig/src/backend/commands/analyze.c postgresql/src/backend/commands/analyze.c
*** postgresql.orig/src/backend/commands/analyze.c	2011-09-12 09:54:31.169314275 +0200
--- postgresql/src/backend/commands/analyze.c	2011-09-13 11:15:14.977046160 +0200
*************** compute_scalar_stats(VacAttrStatsP stats
*** 2502,2519 ****
  			for (i = 0; i < num_mcv; i++)
  			{
  				mcv_values[i] = datumCopy(values[track[i].first].value,
! 										  stats->attrtype->typbyval,
! 										  stats->attrtype->typlen);
  				mcv_freqs[i] = (double) track[i].count / (double) samplerows;
  			}
  			MemoryContextSwitchTo(old_context);
  
! 			stats->stakind[slot_idx] = STATISTIC_KIND_MCV;
! 			stats->staop[slot_idx] = mystats->eqopr;
! 			stats->stanumbers[slot_idx] = mcv_freqs;
! 			stats->numnumbers[slot_idx] = num_mcv;
! 			stats->stavalues[slot_idx] = mcv_values;
! 			stats->numvalues[slot_idx] = num_mcv;
  
  			/*
  			 * Accept the defaults for stats->statypid and others. They have
--- 2812,2829 ----
  			for (i = 0; i < num_mcv; i++)
  			{
  				mcv_values[i] = datumCopy(values[track[i].first].value,
! 										  stats->attrtypes[index]->typbyval,
! 										  stats->attrtypes[index]->typlen);
  				mcv_freqs[i] = (double) track[i].count / (double) samplerows;
  			}
  			MemoryContextSwitchTo(old_context);
  
! 			stats->stakind[index][slot_idx] = STATISTIC_KIND_MCV;
! 			stats->staop[index][slot_idx] = mystats->eqopr;
! 			stats->stanumbers[index][slot_idx] = mcv_freqs;
! 			stats->numnumbers[index][slot_idx] = num_mcv;
! 			stats->stavalues[index][slot_idx] = mcv_values;
! 			stats->numvalues[index][slot_idx] = num_mcv;
  
  			/*
  			 * Accept the defaults for stats->statypid and others. They have
*************** compute_scalar_stats(VacAttrStatsP stats
*** 2609,2616 ****
  			for (i = 0; i < num_hist; i++)
  			{
  				hist_values[i] = datumCopy(values[pos].value,
! 										   stats->attrtype->typbyval,
! 										   stats->attrtype->typlen);
  				pos += delta;
  				posfrac += deltafrac;
  				if (posfrac >= (num_hist - 1))
--- 2919,2926 ----
  			for (i = 0; i < num_hist; i++)
  			{
  				hist_values[i] = datumCopy(values[pos].value,
! 										   stats->attrtypes[index]->typbyval,
! 										   stats->attrtypes[index]->typlen);
  				pos += delta;
  				posfrac += deltafrac;
  				if (posfrac >= (num_hist - 1))
*************** compute_scalar_stats(VacAttrStatsP stats
*** 2623,2632 ****
  
  			MemoryContextSwitchTo(old_context);
  
! 			stats->stakind[slot_idx] = STATISTIC_KIND_HISTOGRAM;
! 			stats->staop[slot_idx] = mystats->ltopr;
! 			stats->stavalues[slot_idx] = hist_values;
! 			stats->numvalues[slot_idx] = num_hist;
  
  			/*
  			 * Accept the defaults for stats->statypid and others. They have
--- 2933,2942 ----
  
  			MemoryContextSwitchTo(old_context);
  
! 			stats->stakind[index][slot_idx] = STATISTIC_KIND_HISTOGRAM;
! 			stats->staop[index][slot_idx] = mystats->ltopr;
! 			stats->stavalues[index][slot_idx] = hist_values;
! 			stats->numvalues[index][slot_idx] = num_hist;
  
  			/*
  			 * Accept the defaults for stats->statypid and others. They have
*************** compute_scalar_stats(VacAttrStatsP stats
*** 2666,2675 ****
  			corrs[0] = (values_cnt * corr_xysum - corr_xsum * corr_xsum) /
  				(values_cnt * corr_x2sum - corr_xsum * corr_xsum);
  
! 			stats->stakind[slot_idx] = STATISTIC_KIND_CORRELATION;
! 			stats->staop[slot_idx] = mystats->ltopr;
! 			stats->stanumbers[slot_idx] = corrs;
! 			stats->numnumbers[slot_idx] = 1;
  			slot_idx++;
  		}
  	}
--- 2976,2985 ----
  			corrs[0] = (values_cnt * corr_xysum - corr_xsum * corr_xsum) /
  				(values_cnt * corr_x2sum - corr_xsum * corr_xsum);
  
! 			stats->stakind[index][slot_idx] = STATISTIC_KIND_CORRELATION;
! 			stats->staop[index][slot_idx] = mystats->ltopr;
! 			stats->stanumbers[index][slot_idx] = corrs;
! 			stats->numnumbers[index][slot_idx] = 1;
  			slot_idx++;
  		}
  	}
*************** compute_scalar_stats(VacAttrStatsP stats
*** 2677,2688 ****
  	{
  		/* We found only nulls; assume the column is entirely null */
  		stats->stats_valid = true;
! 		stats->stanullfrac = 1.0;
  		if (is_varwidth)
! 			stats->stawidth = 0;	/* "unknown" */
  		else
! 			stats->stawidth = stats->attrtype->typlen;
! 		stats->stadistinct = 0.0;		/* "unknown" */
  	}
  
  	/* We don't need to bother cleaning up any of our temporary palloc's */
--- 2987,2998 ----
  	{
  		/* We found only nulls; assume the column is entirely null */
  		stats->stats_valid = true;
! 		stats->stanullfrac[index] = 1.0;
  		if (is_varwidth)
! 			stats->stawidth[index] = 0;	/* "unknown" */
  		else
! 			stats->stawidth[index] = stats->attrtypes[index]->typlen;
! 		stats->stadistinct[index] = 0.0;	/* "unknown" */
  	}
  
  	/* We don't need to bother cleaning up any of our temporary palloc's */
*************** compare_scalars(const void *a, const voi
*** 2729,2734 ****
--- 3039,3243 ----
  }
  
  /*
+  * qsort_arg comparator for cross column statistics
+  * The dimension axes need to be properly ordered.
+  */
+ static int
+ compare_datums(const void *a, const void *b, void *arg)
+ {
+ 	Datum		da = *((Datum *) a);
+ 	Datum		db = *((Datum *) b);
+ 	CompareDatumsContext *cxt = (CompareDatumsContext *) arg;
+ 
+ 	return ApplySortFunction(&(cxt->cmpFn), cxt->cmpFlags,
+ 								DEFAULT_COLLATION_OID,
+ 								da, false, db, false);
+ }
+ 
+ /*
+  * Find the index in stavalues for a Datum with ordering operators.
+  * Because it's ordered, we can use the ordering operator for binary searching.
+  * Returns: 0 for a NULL value, >= 1 for a valid index.
+  */
+ static int
+ ordered_findval(VacStatsP stats, int rownum, int index, AnalyzeAttrFetchFunc fetchfunc, void *arg)
+ {
+ 	Datum		value;
+ 	bool		isnull;
+ 	int		idx_lo, idx_hi, idx_mid;
+ 	int32		compare;
+ 	CompareDatumsContext *ctx = (CompareDatumsContext *) arg;
+ 
+ 	value = fetchfunc(stats, rownum, stats->attnums->values[index], &isnull);
+ 	if (isnull)
+ 		return 0;
+ 
+ 	/* Clamp values smaller than the first bucket to the first bucket */
+ 	idx_lo = 0;
+ 	compare = ApplySortFunction(&(ctx->cmpFn), ctx->cmpFlags,
+ 								DEFAULT_COLLATION_OID,
+ 								value, false, stats->stavalues[index][0][idx_lo], false);
+ 	if (compare < 0)
+ 		return idx_lo + 1;
+ 
+ 	/*
+ 	 * Buckets have values greater or equal than the bucket's stavalue
+ 	 * but less than the next bucket's stavalue. There's no next bucket
+ 	 * for the last one, so check it here.
+ 	 */
+ 	idx_hi = stats->numvalues[index][0] - 1;
+ 	compare = ApplySortFunction(&(ctx->cmpFn), ctx->cmpFlags,
+ 								DEFAULT_COLLATION_OID,
+ 								value, false, stats->stavalues[index][0][idx_hi], false);
+ 	if (compare >= 0)
+ 		return idx_hi + 1;
+ 
+ 	idx_mid = (idx_lo + idx_hi) / 2;
+ 
+ 	while (idx_lo < idx_hi && idx_mid > idx_lo)
+ 	{
+ 		compare = ApplySortFunction(&(ctx->cmpFn), ctx->cmpFlags,
+ 								DEFAULT_COLLATION_OID,
+ 								value, false, stats->stavalues[index][0][idx_mid], false);
+ 		if (compare < 0)
+ 			idx_hi = idx_mid - 1;
+ 		else /* if (compare >= 0) */
+ 			idx_lo = idx_mid;
+ 
+ 		idx_mid = (idx_lo + idx_hi) / 2;
+ 	}
+ 
+ 	return idx_lo + 1;
+ }
+ 
+ /*
+  * Find the index in stavalues for a Datum with equality operator only.
+  * Byte the bullet and loop through the stavalues array.
+  * Returns: 0 for NULL value, >= 1 for a valid index and -1 for a Datum
+  * that isn't in stavalues (ignored value).
+  */
+ static int
+ unordered_findval(VacStatsP stats, int rownum, int index, AnalyzeAttrFetchFunc fetchfunc, void *arg)
+ {
+ 	CompareDatumsContext *ctx = (CompareDatumsContext *) arg;
+ 	Datum		value;
+ 	bool		isnull;
+ 	int		i;
+ 
+ 	value = fetchfunc(stats, rownum, stats->attnums->values[index], &isnull);
+ 	if (isnull)
+ 		return 0;
+ 
+ 	for (i = 0; i < stats->numvalues[index][0]; i++)
+ 	{
+ 		if (DatumGetBool(FunctionCall2Coll(&(ctx->cmpFn),
+ 								DEFAULT_COLLATION_OID,
+ 								value, stats->stavalues[index][0][i])))
+ 			return i + 1;
+ 	}
+ 
+ 	return -1;
+ }
+ 
+ /*
+  * Compute a cross-column statistics.
+  */
+ static void
+ compute_cross_column_stats(VacStatsP stats, AnalyzeAttrFetchFunc fetchfunc, int numrows)
+ {
+ 	int			i, j, numvalues;
+ 	int			dimstride[STATISTIC_NUM_SLOTS];
+ 	MemoryContext		old_context;
+ 	CompareDatumsContext	ctx[STATISTIC_NUM_SLOTS];
+ 	float4		   *hist;
+ 
+ 	/* Don't touch single column statistics. */
+ 	if (stats->attnums->dim1 == 1)
+ 		return;
+ 
+ 	/*
+ 	 * Don't compute cross-column statistics if there is no way to find
+ 	 * a Datum's index in the stavalues[] array
+ 	 */
+ 	for (i = 0; i < stats->attnums->dim1; i++)
+ 		if (stats->statfuncs[i].findval_func_ptr == NULL)
+ 			return;
+ 
+ 	/* We need ordered stavalues arrays whenever possible. */
+ 	for (i = 0; i < stats->attnums->dim1; i++)
+ 	{
+ 		StdAnalyzeData *mystats = (StdAnalyzeData *) stats->extra_data[i];
+ 
+ 		if (OidIsValid(mystats->ltopr))
+ 		{
+ 			Oid	cmpFn;
+ 
+ 			SelectSortFunction(mystats->ltopr, false, &cmpFn, &(ctx[i].cmpFlags));
+ 			fmgr_info(cmpFn, &(ctx[i].cmpFn));
+ 
+ 			qsort_arg((void *) stats->stavalues[i][0], stats->numvalues[i][0], sizeof(Datum),
+ 										  compare_datums, (void *) &ctx[i]);
+ 		}
+ 		else
+ 			fmgr_info(mystats->eqfunc, &(ctx[i].cmpFn));
+ 	}
+ 
+ 	/* Free up previously computed stanumbers arrays. */
+ 	for (i = 0; i < STATISTIC_NUM_SLOTS; i++)
+ 		for (j = 0; j < STATISTIC_NUM_SLOTS; j++)
+ 		{
+ 			if (stats->stanumbers[i][j])
+ 			{
+ 				pfree(stats->stanumbers[i][j]);
+ 				stats->stanumbers[i][j] = NULL;
+ 			}
+ 			stats->numnumbers[i][j] = 0;
+ 		}
+ 
+ 	/*
+ 	 * Compute the size of the N-dimension histogram and the dimension stride values.
+ 	 * The histogram cells at the 0th index of a dimension is the nullfrac value,
+ 	 * hence the + 1.
+ 	 */
+ 	for (i = 0, numvalues = 1; i < stats->attnums->dim1; i++)
+ 	{
+ 		dimstride[stats->attnums->dim1 - i - 1] = numvalues;
+ 		numvalues *= stats->numvalues[i][0] + 1;
+ 	}
+ 
+ 	old_context = MemoryContextSwitchTo(stats->anl_context);
+ 
+ 	hist = (float *) palloc(numvalues * sizeof(float));
+ 	for (i = 0; i < numvalues; i++)
+ 		hist[i] = 0.0;
+ 
+ 	MemoryContextSwitchTo(old_context);
+ 
+ 	for (i = 0; i < numrows; i++)
+ 	{
+ 		int	idx, idx_tmp;
+ 
+ 		idx = 0;
+ 		for (j = 0; j < stats->attnums->dim1; j++)
+ 		{
+ 			idx_tmp = stats->statfuncs[j].findval_func_ptr(stats, i, j, fetchfunc, &ctx[j]);
+ 			if (idx_tmp < 0)
+ 				continue;
+ 
+ 			idx += idx_tmp * dimstride[j];
+ 		}
+ 		hist[idx] = hist[idx] + 1.0;
+ 	}
+ 
+ 	/* Store selectivity instead of actual counts. */
+ 	for (i = 0; i < numvalues; i ++)
+ 		hist[i] /= numrows;
+ 
+ 	stats->numnumbers[0][0] = numvalues;
+ 	stats->stanumbers[0][0] = hist;
+ }
+ 
+ /*
   * qsort comparator for sorting ScalarMCVItems by position
   */
  static int
*************** compare_mcvs(const void *a, const void *
*** 2739,2741 ****
--- 3248,3321 ----
  
  	return da - db;
  }
+ 
+ /*
+  * ExtraColStat
+  *     Add or remove one extra entry in pg_statistics
+  */
+ void ExtraStatistics(ExtraStatStmt *stmt)
+ {
+ 	Oid		relId;
+ 	int		len, i, j;
+ 	bool		differ = false;
+ 	AttrNumber	   *attnums;
+ 	AttrNumber	   *sorted_attnums;
+ 	ListCell	   *l;
+ 
+ 	relId = RangeVarGetRelid(stmt->relation, AccessExclusiveLock, false, false);
+ 
+ 	len = list_length(stmt->columns);
+ 	if (len < 2)
+ 		elog(ERROR, "cross column statistics need at least two columns");
+ 	if (len > STATISTIC_NUM_SLOTS)
+ 		elog(ERROR, "cross column statistics can cover at most %d columns", STATISTIC_NUM_SLOTS);
+ 
+ 	attnums = (int2 *)palloc(len * sizeof(AttrNumber));
+ 	sorted_attnums = (int2 *)palloc(len * sizeof(AttrNumber));
+ 
+ 	i = 0;
+ 	foreach(l, stmt->columns)
+ 	{
+ 		Node	   *node = (Node *) lfirst(l);
+ 		Var	   *var;
+ 
+ 		if (!IsA(node, Var))
+ 			elog(ERROR, "not a column reference");
+ 
+ 		var = (Var *) node;
+ 
+ 		if (var->varattno == 0)
+ 			elog(ERROR, "row expansion via \"*\" is not supported here");
+ 
+ 		sorted_attnums[i] = attnums[i] = var->varattno;
+ 
+ 		i++;
+ 	}
+ 
+ 	for (i = 0;  i < len - 1; i++)
+ 		for (j = i+1; j < len; j++)
+ 			if (sorted_attnums[i] > sorted_attnums[j])
+ 			{
+ 				AttrNumber	tmp = sorted_attnums[i];
+ 
+ 				sorted_attnums[i] = sorted_attnums[j];
+ 				sorted_attnums[j] = tmp;
+ 			}
+ 
+ 	for (i = 0; i < len; i++)
+ 	{
+ 		if (!differ && attnums[i] != sorted_attnums[i])
+ 			differ = true;
+ 
+ 		if ((i < len - 1) && sorted_attnums[i] == sorted_attnums[i+1])
+ 			elog(ERROR, "column list must contain every column exactly once");
+ 
+ 	}
+ 	if (differ)
+ 		elog(WARNING, "the column list was reordered in the order of table attributes");
+ 
+ 	if (stmt->create)
+ 		AddStatistics(relId, sorted_attnums, len, false, stmt->statistics_target);
+ 	else
+ 		RemoveStatistics(relId, sorted_attnums, len);
+ }
diff -dcrpN postgresql.orig/src/backend/commands/tablecmds.c postgresql/src/backend/commands/tablecmds.c
*** postgresql.orig/src/backend/commands/tablecmds.c	2011-09-05 15:08:06.505567943 +0200
--- postgresql/src/backend/commands/tablecmds.c	2011-09-12 10:01:16.543508362 +0200
***************
*** 35,40 ****
--- 35,41 ----
  #include "catalog/pg_inherits_fn.h"
  #include "catalog/pg_namespace.h"
  #include "catalog/pg_opclass.h"
+ #include "catalog/pg_statistic.h"
  #include "catalog/pg_tablespace.h"
  #include "catalog/pg_trigger.h"
  #include "catalog/pg_type.h"
*************** ATExecAddColumn(List **wqueue, AlteredTa
*** 4341,4347 ****
  	attribute.attrelid = myrelid;
  	namestrcpy(&(attribute.attname), colDef->colname);
  	attribute.atttypid = typeOid;
- 	attribute.attstattarget = (newattnum > 0) ? -1 : 0;
  	attribute.attlen = tform->typlen;
  	attribute.attcacheoff = -1;
  	attribute.atttypmod = typmod;
--- 4342,4347 ----
*************** ATExecAddColumn(List **wqueue, AlteredTa
*** 4503,4508 ****
--- 4503,4510 ----
  	add_column_datatype_dependency(myrelid, newattnum, attribute.atttypid);
  	add_column_collation_dependency(myrelid, newattnum, attribute.attcollation);
  
+ 	AddStatistics(myrelid, &attribute.attnum, 1, attribute.attinhcount, (newattnum > 0) ? -1 : 0);
+ 
  	/*
  	 * Propagate to children as appropriate.  Unlike most other ALTER
  	 * routines, we have to do this one level of recursion at a time; we can't
*************** ATExecSetStatistics(Relation rel, const 
*** 4839,4846 ****
--- 4841,4854 ----
  {
  	int			newtarget;
  	Relation	attrelation;
+ 	Relation	statsrelation;
+ 	Oid		relid;
  	HeapTuple	tuple;
  	Form_pg_attribute attrtuple;
+ 	AttrNumber	attnum;
+ 	bool		inherited;
+ 	int2vector *attnumvector;
+ 	Form_pg_statistic stattuple;
  
  	Assert(IsA(newValue, Integer));
  	newtarget = intVal(newValue);
*************** ATExecSetStatistics(Relation rel, const 
*** 4866,4872 ****
  
  	attrelation = heap_open(AttributeRelationId, RowExclusiveLock);
  
! 	tuple = SearchSysCacheCopyAttName(RelationGetRelid(rel), colName);
  
  	if (!HeapTupleIsValid(tuple))
  		ereport(ERROR,
--- 4874,4882 ----
  
  	attrelation = heap_open(AttributeRelationId, RowExclusiveLock);
  
! 	relid = RelationGetRelid(rel);
! 
! 	tuple = SearchSysCacheAttName(relid, colName);
  
  	if (!HeapTupleIsValid(tuple))
  		ereport(ERROR,
*************** ATExecSetStatistics(Relation rel, const 
*** 4881,4896 ****
  				 errmsg("cannot alter system column \"%s\"",
  						colName)));
  
! 	attrtuple->attstattarget = newtarget;
  
! 	simple_heap_update(attrelation, &tuple->t_self, tuple);
  
! 	/* keep system catalog indexes current */
! 	CatalogUpdateIndexes(attrelation, tuple);
  
! 	heap_freetuple(tuple);
  
! 	heap_close(attrelation, RowExclusiveLock);
  }
  
  static void
--- 4891,4931 ----
  				 errmsg("cannot alter system column \"%s\"",
  						colName)));
  
! 	attnum = attrtuple->attnum;
! 	inherited = (attrtuple->attinhcount > 0);
  
! 	ReleaseSysCache(tuple);
  
! 	heap_close(attrelation, RowExclusiveLock);
  
! 	statsrelation = heap_open(StatisticRelationId, RowExclusiveLock);
  
! 	attnumvector = buildint2vector(&attnum, 1);
! 
! 	tuple = SearchSysCacheCopy3(STATRELATTINH,
! 								ObjectIdGetDatum(relid),
! 								PointerGetDatum(attnumvector),
! 								BoolGetDatum(inherited));
! 
! 	pfree(attnumvector);
! 
! 	if (!HeapTupleIsValid(tuple))
! 		AddStatistics(relid, &attnum, 1, inherited, newtarget);
! 	else
! 	{
! 		stattuple = (Form_pg_statistic) GETSTRUCT(tuple);
! 
! 		stattuple->statarget = newtarget;
! 
! 		simple_heap_update(statsrelation, &tuple->t_self, tuple);
! 
! 		/* keep system catalog indexes current */
! 		CatalogUpdateIndexes(statsrelation, tuple);
! 
! 		heap_freetuple(tuple);
! 	}
! 
! 	heap_close(statsrelation, RowExclusiveLock);
  }
  
  static void
*************** ATExecAlterColumnType(AlteredTableInfo *
*** 7390,7398 ****
  	add_column_collation_dependency(RelationGetRelid(rel), attnum, targetcollid);
  
  	/*
! 	 * Drop any pg_statistic entry for the column, since it's now wrong type
  	 */
! 	RemoveStatistics(RelationGetRelid(rel), attnum);
  
  	/*
  	 * Update the default, if present, by brute force --- remove and re-add
--- 7425,7433 ----
  	add_column_collation_dependency(RelationGetRelid(rel), attnum, targetcollid);
  
  	/*
! 	 * Invalidate any pg_statistic entry for the column, since it's now wrong type
  	 */
! 	InvalidateStatistics(RelationGetRelid(rel), attnum);
  
  	/*
  	 * Update the default, if present, by brute force --- remove and re-add
diff -dcrpN postgresql.orig/src/backend/executor/nodeHash.c postgresql/src/backend/executor/nodeHash.c
*** postgresql.orig/src/backend/executor/nodeHash.c	2011-09-02 12:52:41.347575337 +0200
--- postgresql/src/backend/executor/nodeHash.c	2011-09-12 10:01:16.578506729 +0200
***************
*** 32,37 ****
--- 32,38 ----
  #include "executor/nodeHash.h"
  #include "executor/nodeHashjoin.h"
  #include "miscadmin.h"
+ #include "utils/builtins.h"
  #include "utils/dynahash.h"
  #include "utils/memutils.h"
  #include "utils/lsyscache.h"
*************** ExecHashBuildSkewHash(HashJoinTable hash
*** 1125,1130 ****
--- 1126,1132 ----
  	int			nvalues;
  	float4	   *numbers;
  	int			nnumbers;
+ 	int2vector *attnumvector;
  
  	/* Do nothing if planner didn't identify the outer relation's join key */
  	if (!OidIsValid(node->skewTable))
*************** ExecHashBuildSkewHash(HashJoinTable hash
*** 1136,1145 ****
  	/*
  	 * Try to find the MCV statistics for the outer relation's join key.
  	 */
  	statsTuple = SearchSysCache3(STATRELATTINH,
  								 ObjectIdGetDatum(node->skewTable),
! 								 Int16GetDatum(node->skewColumn),
  								 BoolGetDatum(node->skewInherit));
  	if (!HeapTupleIsValid(statsTuple))
  		return;
  
--- 1138,1160 ----
  	/*
  	 * Try to find the MCV statistics for the outer relation's join key.
  	 */
+ 	attnumvector = buildint2vector(&(node->skewColumn), 1);
  	statsTuple = SearchSysCache3(STATRELATTINH,
  								 ObjectIdGetDatum(node->skewTable),
! 								 PointerGetDatum(attnumvector),
  								 BoolGetDatum(node->skewInherit));
+ 	pfree(attnumvector);
+ 
+ 	/* check whether the stats entry is valid */
+ 	if (HeapTupleIsValid(statsTuple))
+ 	{
+ 		if (!((Form_pg_statistic)GETSTRUCT(statsTuple))->stavalid)
+ 		{
+ 			ReleaseSysCache(statsTuple);
+ 			statsTuple = NULL;
+ 		}
+ 	}
+ 
  	if (!HeapTupleIsValid(statsTuple))
  		return;
  
diff -dcrpN postgresql.orig/src/backend/nodes/copyfuncs.c postgresql/src/backend/nodes/copyfuncs.c
*** postgresql.orig/src/backend/nodes/copyfuncs.c	2011-09-05 15:08:06.513567349 +0200
--- postgresql/src/backend/nodes/copyfuncs.c	2011-09-12 10:01:16.585506400 +0200
*************** _copyCreateForeignTableStmt(CreateForeig
*** 3455,3460 ****
--- 3455,3473 ----
  	return newnode;
  }
  
+ static ExtraStatStmt *
+ _copyExtraStatStmt(ExtraStatStmt *from)
+ {
+ 	ExtraStatStmt *newnode = makeNode(ExtraStatStmt);
+ 
+ 	COPY_SCALAR_FIELD(create);
+ 	newnode->relation = _copyRangeVar(from->relation);
+ 	COPY_NODE_FIELD(columns);
+ 	COPY_SCALAR_FIELD(statistics_target);
+ 
+ 	return newnode;
+ }
+ 
  static CreateTrigStmt *
  _copyCreateTrigStmt(CreateTrigStmt *from)
  {
*************** copyObject(void *from)
*** 4374,4379 ****
--- 4387,4395 ----
  		case T_CreateForeignTableStmt:
  			retval = _copyCreateForeignTableStmt(from);
  			break;
+ 		case T_ExtraStatStmt:
+ 			retval = _copyExtraStatStmt(from);
+ 			break;
  		case T_CreateTrigStmt:
  			retval = _copyCreateTrigStmt(from);
  			break;
diff -dcrpN postgresql.orig/src/backend/nodes/equalfuncs.c postgresql/src/backend/nodes/equalfuncs.c
*** postgresql.orig/src/backend/nodes/equalfuncs.c	2011-07-24 18:16:45.269678833 +0200
--- postgresql/src/backend/nodes/equalfuncs.c	2011-09-12 10:01:16.605505468 +0200
*************** _equalCreateForeignTableStmt(CreateForei
*** 1796,1801 ****
--- 1796,1813 ----
  }
  
  static bool
+ _equalExtraStatStmt(ExtraStatStmt *a, ExtraStatStmt *b)
+ {
+ 	COMPARE_SCALAR_FIELD(create);
+ 	if (!_equalRangeVar(a->relation, b->relation))
+ 		return FALSE;
+ 	COMPARE_NODE_FIELD(columns);
+ 	COMPARE_SCALAR_FIELD(statistics_target);
+ 
+ 	return true;
+ }
+ 
+ static bool
  _equalCreateTrigStmt(CreateTrigStmt *a, CreateTrigStmt *b)
  {
  	COMPARE_STRING_FIELD(trigname);
*************** equal(void *a, void *b)
*** 2931,2936 ****
--- 2943,2951 ----
  		case T_CreateForeignTableStmt:
  			retval = _equalCreateForeignTableStmt(a, b);
  			break;
+ 		case T_ExtraStatStmt:
+ 			retval = _equalExtraStatStmt(a, b);
+ 			break;
  		case T_CreateTrigStmt:
  			retval = _equalCreateTrigStmt(a, b);
  			break;
diff -dcrpN postgresql.orig/src/backend/parser/gram.y postgresql/src/backend/parser/gram.y
*** postgresql.orig/src/backend/parser/gram.y	2011-08-07 11:29:16.020256051 +0200
--- postgresql/src/backend/parser/gram.y	2011-09-12 10:01:16.618504860 +0200
*************** static void processCASbits(int cas_bits,
*** 214,220 ****
  		DropGroupStmt DropOpClassStmt DropOpFamilyStmt DropPLangStmt DropStmt
  		DropAssertStmt DropTrigStmt DropRuleStmt DropCastStmt DropRoleStmt
  		DropUserStmt DropdbStmt DropTableSpaceStmt DropFdwStmt
! 		DropForeignServerStmt DropUserMappingStmt ExplainStmt FetchStmt
  		GrantStmt GrantRoleStmt IndexStmt InsertStmt ListenStmt LoadStmt
  		LockStmt NotifyStmt ExplainableStmt PreparableStmt
  		CreateFunctionStmt AlterFunctionStmt ReindexStmt RemoveAggrStmt
--- 214,220 ----
  		DropGroupStmt DropOpClassStmt DropOpFamilyStmt DropPLangStmt DropStmt
  		DropAssertStmt DropTrigStmt DropRuleStmt DropCastStmt DropRoleStmt
  		DropUserStmt DropdbStmt DropTableSpaceStmt DropFdwStmt
! 		DropForeignServerStmt DropUserMappingStmt ExplainStmt ExtraStatStmt FetchStmt
  		GrantStmt GrantRoleStmt IndexStmt InsertStmt ListenStmt LoadStmt
  		LockStmt NotifyStmt ExplainableStmt PreparableStmt
  		CreateFunctionStmt AlterFunctionStmt ReindexStmt RemoveAggrStmt
*************** static void processCASbits(int cas_bits,
*** 246,252 ****
  				transaction_mode_item
  				create_extension_opt_item alter_extension_opt_item
  
! %type <ival>	opt_lock lock_type cast_context
  %type <ival>	vacuum_option_list vacuum_option_elem
  %type <boolean>	opt_force opt_or_replace
  				opt_grant_grant_option opt_grant_admin_option
--- 246,252 ----
  				transaction_mode_item
  				create_extension_opt_item alter_extension_opt_item
  
! %type <ival>	opt_lock lock_type cast_context opt_stattarget
  %type <ival>	vacuum_option_list vacuum_option_elem
  %type <boolean>	opt_force opt_or_replace
  				opt_grant_grant_option opt_grant_admin_option
*************** static void processCASbits(int cas_bits,
*** 325,330 ****
--- 325,332 ----
  %type <list>	opt_fdw_options fdw_options
  %type <defelt>	fdw_option
  
+ %type <list>	cc_column_list
+ 
  %type <range>	OptTempTableName
  %type <into>	into_clause create_as_target
  
*************** stmt :
*** 756,761 ****
--- 758,764 ----
  			| DropdbStmt
  			| ExecuteStmt
  			| ExplainStmt
+ 			| ExtraStatStmt
  			| FetchStmt
  			| GrantStmt
  			| GrantRoleStmt
*************** schema_stmt:
*** 1200,1205 ****
--- 1203,1276 ----
  
  /*****************************************************************************
   *
+  * Add / drop extra statistics
+  *
+  *****************************************************************************/
+ 
+ ExtraStatStmt:
+ 			CREATE CROSS COLUMN STATISTICS ON TABLE qualified_name '(' cc_column_list ')' opt_stattarget
+ 				{
+ 					ExtraStatStmt *n = makeNode(ExtraStatStmt);
+ 
+ 					n->relkind = 'r';
+ 					n->create = true;
+ 					n->relation = $7;
+ 					n->columns = $9;
+ 					n->statistics_target = $11;
+ 					$$ = (Node *)n;
+ 				}
+ 			| DROP CROSS COLUMN STATISTICS ON TABLE qualified_name '(' cc_column_list ')'
+ 				{
+ 					ExtraStatStmt *n = makeNode(ExtraStatStmt);
+ 
+ 					n->relkind = 'r';
+ 					n->create = false;
+ 					n->relation = $7;
+ 					n->columns = $9;
+ 					$$ = (Node *)n;
+ 				}
+ 			| CREATE CROSS COLUMN STATISTICS ON INDEX qualified_name opt_stattarget
+ 				{
+ 					ExtraStatStmt *n = makeNode(ExtraStatStmt);
+ 
+ 					n->relkind = 'i';
+ 					n->create = true;
+ 					n->relation = $7;
+ 					n->columns = NIL;
+ 					n->statistics_target = $8;
+ 					$$ = (Node *)n;
+ 				}
+ 			| DROP CROSS COLUMN STATISTICS ON INDEX qualified_name
+ 				{
+ 					ExtraStatStmt *n = makeNode(ExtraStatStmt);
+ 
+ 					n->relkind = 'i';
+ 					n->create = false;
+ 					n->relation = $7;
+ 					n->columns = NIL;
+ 					$$ = (Node *)n;
+ 				}
+ 		;
+ 
+ cc_column_list:
+ 			columnref
+ 				{
+ 					$$ = list_make1($1);
+ 				}
+ 			| cc_column_list ',' columnref
+ 				{
+ 					$$ = lappend($1, $3);
+ 				}
+ 		;
+ 
+ opt_stattarget:
+ 			WITH '(' Iconst ')'			{ $$ = $3; }
+ 			| /* EMPTY */				{ $$ = -1; }
+ 		;
+ 
+ 
+ /*****************************************************************************
+  *
   * Set PG internal variable
   *	  SET name TO 'var_value'
   * Include SQL92 syntax (thomas 1997-10-22):
diff -dcrpN postgresql.orig/src/backend/parser/parse_utilcmd.c postgresql/src/backend/parser/parse_utilcmd.c
*** postgresql.orig/src/backend/parser/parse_utilcmd.c	2011-09-02 12:52:41.361574202 +0200
--- postgresql/src/backend/parser/parse_utilcmd.c	2011-09-12 10:01:16.630504299 +0200
*************** setSchemaName(char *context_schema, char
*** 2732,2734 ****
--- 2732,2827 ----
  						"different from the one being created (%s)",
  						*stmt_schema_name, context_schema)));
  }
+ 
+ /*
+  * transformExtraStatistics
+  *             Transform the column list or the expression into a form
+  *             usable by the executor.
+  */
+ ExtraStatStmt *
+ transformExtraStatistics(ExtraStatStmt *stmt, const char *queryString)
+ {
+ 	ParseState	   *pstate;
+ 	RangeTblEntry	   *rte;
+ 	ExtraStatStmt	   *newstmt;
+ 	List		   *columns = NIL;
+ 	ListCell	   *cell;
+ 	Oid			relId;
+ 	HeapTuple		tuple;
+ 	HeapTuple		attuple;
+ 	Form_pg_class		classptr;
+ 	Form_pg_index		indexptr;
+ 	Form_pg_attribute	attptr;
+ 	AttrNumber		i;
+ 
+ 	switch (stmt->relkind)
+ 	{
+ 		case 'r':
+ 			pstate = make_parsestate(NULL);
+ 			pstate->p_sourcetext = queryString;
+ 
+ 			rte = addRangeTableEntry(pstate, stmt->relation, NULL, false, true);
+ 			addRTEtoQuery(pstate, rte, true, true, true);
+ 
+ 			foreach(cell, stmt->columns)
+ 			{
+ 				Node *col = lfirst(cell);
+ 
+ 				columns = lappend(columns, transformExpr(pstate, col));
+ 			}
+ 
+ 			break;
+ 
+ 		case 'i':
+ 			relId = RangeVarGetRelid(stmt->relation, ShareLock, false, false);
+ 
+ 			tuple = SearchSysCache1(RELOID, relId);
+ 			classptr = (Form_pg_class) GETSTRUCT(tuple);
+ 
+ 			if (classptr->relkind != 'i')
+ 				elog(ERROR, "not an index");
+ 
+ 			ReleaseSysCache(tuple);
+ 
+ 			tuple = SearchSysCache1(INDEXRELID, relId);
+ 			indexptr = (Form_pg_index) GETSTRUCT(tuple);
+ 
+ 			if (indexptr->indnatts < 2)
+ 			{
+ 				ReleaseSysCache(tuple);
+ 
+ 				elog(ERROR, "cross column statistics are only usable on multi-column indexes");
+ 			}
+ 
+ 			for (i = 1; i <= indexptr->indnatts; i++)
+ 			{
+ 				attuple = SearchSysCache2(ATTNUM, relId, i);
+ 				if (!HeapTupleIsValid(attuple))
+ 					elog(ERROR, "pg_attribute row not found for index");
+ 
+ 				attptr = (Form_pg_attribute) GETSTRUCT(attuple);
+ 
+ 				columns = lappend(columns, makeVar(0, i,
+ 										attptr->atttypid,
+ 										attptr->atttypmod,
+ 										InvalidOid, 0));
+ 
+ 				ReleaseSysCache(attuple);
+ 			}
+ 
+ 			ReleaseSysCache(tuple);
+ 			break;
+ 
+ 		default:
+ 			elog(ERROR, "invalid relkind");
+ 	}
+ 
+ 	newstmt = makeNode(ExtraStatStmt);
+ 	newstmt->relkind = stmt->relkind;
+ 	newstmt->create = stmt->create;
+ 	newstmt->relation = copyObject(stmt->relation);
+ 	newstmt->columns = columns;
+ 	newstmt->statistics_target = stmt->statistics_target;
+ 
+ 	return newstmt;
+ }
diff -dcrpN postgresql.orig/src/backend/tcop/utility.c postgresql/src/backend/tcop/utility.c
*** postgresql.orig/src/backend/tcop/utility.c	2011-07-24 18:16:45.276678481 +0200
--- postgresql/src/backend/tcop/utility.c	2011-09-12 10:01:16.639503878 +0200
*************** check_xact_readonly(Node *parsetree)
*** 237,242 ****
--- 237,243 ----
  		case T_AlterTableSpaceOptionsStmt:
  		case T_CreateForeignTableStmt:
  		case T_SecLabelStmt:
+ 		case T_ExtraStatStmt:
  			PreventCommandIfReadOnly(CreateCommandTag(parsetree));
  			break;
  		default:
*************** standard_ProcessUtility(Node *parsetree,
*** 581,586 ****
--- 582,595 ----
  			}
  			break;
  
+ 		case T_ExtraStatStmt:
+ 			{
+ 				ExtraStatStmt *newstmt = transformExtraStatistics((ExtraStatStmt *)parsetree, queryString);
+ 
+ 				ExtraStatistics(newstmt);
+ 			}
+ 			break;
+ 
  		case T_CreateTableSpaceStmt:
  			PreventTransactionChain(isTopLevel, "CREATE TABLESPACE");
  			CreateTableSpace((CreateTableSpaceStmt *) parsetree);
*************** CreateCommandTag(Node *parsetree)
*** 1744,1749 ****
--- 1753,1769 ----
  			tag = "CREATE FOREIGN TABLE";
  			break;
  
+ 		case T_ExtraStatStmt:
+ 			{
+ 				ExtraStatStmt *stmt = (ExtraStatStmt *)parsetree;
+ 
+ 				if (stmt->create)
+ 					tag = "CREATE CROSS COLUMN STATISTICS";
+ 				else
+ 					tag = "DROP CROSS COLUMN STATISTICS";
+ 			}
+ 			break;
+ 
  		case T_DropStmt:
  			switch (((DropStmt *) parsetree)->removeType)
  			{
